Index: src/highlighting.c
===================================================================
--- src/highlighting.c	(revision 3458)
+++ src/highlighting.c	(working copy)
@@ -564,11 +564,11 @@
 	SSM(sci,SCI_MARKERSETFORE, SC_MARKNUM_FOLDERMIDTAIL, 0xffffff);
 	SSM(sci,SCI_MARKERSETBACK, SC_MARKNUM_FOLDERMIDTAIL, 0x000000);
 
-	SSM(sci, SCI_SETPROPERTY, (sptr_t) "fold", (sptr_t) "1");
-	SSM(sci, SCI_SETPROPERTY, (sptr_t) "fold.compact", (sptr_t) "0");
-	SSM(sci, SCI_SETPROPERTY, (sptr_t) "fold.comment", (sptr_t) "1");
-	SSM(sci, SCI_SETPROPERTY, (sptr_t) "fold.preprocessor", (sptr_t) "1");
-	SSM(sci, SCI_SETPROPERTY, (sptr_t) "fold.at.else", (sptr_t) "1");
+	SSM(sci, SCI_SETPROPERTY, (uptr_t) "fold", (sptr_t) "1");
+	SSM(sci, SCI_SETPROPERTY, (uptr_t) "fold.compact", (sptr_t) "0");
+	SSM(sci, SCI_SETPROPERTY, (uptr_t) "fold.comment", (sptr_t) "1");
+	SSM(sci, SCI_SETPROPERTY, (uptr_t) "fold.preprocessor", (sptr_t) "1");
+	SSM(sci, SCI_SETPROPERTY, (uptr_t) "fold.at.else", (sptr_t) "1");
 
 
 	/* bold (3rd argument) is whether to override default foreground selection */
Index: src/keybindings.c
===================================================================
--- src/keybindings.c	(revision 3458)
+++ src/keybindings.c	(working copy)
@@ -487,7 +487,7 @@
 
 
 /* before the tab changes, add the current document to the MRU list */
-static void on_notebook_switch_page()
+static void on_notebook_switch_page(void)
 {
 	GeanyDocument *old = document_get_current();
 
Index: src/callbacks.c
===================================================================
--- src/callbacks.c	(revision 3458)
+++ src/callbacks.c	(working copy)
@@ -1216,7 +1216,7 @@
 
 		if (doc != NULL)
 		{
-			if (! editor_goto_line(doc->editor, val - 1))
+			if (! editor_goto_line(doc->editor, (gint)val - 1))
 				utils_beep();
 		}
 	}
Index: src/filetypes.c
===================================================================
--- src/filetypes.c	(revision 3458)
+++ src/filetypes.c	(working copy)
@@ -654,7 +654,7 @@
 	gtk_widget_show((item));
 
 
-static void create_set_filetype_menu()
+static void create_set_filetype_menu(void)
 {
 	filetype_id ft_id;
 	GtkWidget *filetype_menu = ui_lookup_widget(main_widgets.window, "set_filetype1_menu");
Index: src/search.c
===================================================================
--- src/search.c	(revision 3458)
+++ src/search.c	(working copy)
@@ -316,7 +316,7 @@
  * search dialogs. This needs to be done only once.
  * The monospace font should increase readibility of regular expressions containing spaces, points,
  * commas and similar (#1907117). */
-static void load_monospace_style()
+static void load_monospace_style(void)
 {
 	static const gchar *rcstyle =
 		"style \"geany-monospace\"\n" \
@@ -601,7 +601,7 @@
 }
 
 
-static void create_fif_dialog()
+static void create_fif_dialog(void)
 {
 	GtkWidget *dir_combo, *combo, *e_combo, *entry;
 	GtkWidget *label, *label1, *label2, *checkbox1, *checkbox2, *check_wholeword,
Index: src/document.c
===================================================================
--- src/document.c	(revision 3458)
+++ src/document.c	(working copy)
@@ -530,7 +530,7 @@
 
 
 /* Opens a new empty document only if there are no other documents open */
-GeanyDocument *document_new_file_if_non_open()
+GeanyDocument *document_new_file_if_non_open(void)
 {
 	if (gtk_notebook_get_n_pages(GTK_NOTEBOOK(main_widgets.notebook)) == 0)
 		return document_new_file(NULL, NULL, NULL);
Index: src/plugins.c
===================================================================
--- src/plugins.c	(revision 3458)
+++ src/plugins.c	(working copy)
@@ -735,7 +735,7 @@
 
 /* load active plugins at startup */
 static void
-load_active_plugins()
+load_active_plugins(void)
 {
 	guint i, len;
 
Index: src/document.h
===================================================================
--- src/document.h	(revision 3458)
+++ src/document.h	(working copy)
@@ -138,7 +138,7 @@
 
 GeanyDocument* document_new_file(const gchar *filename, GeanyFiletype *ft, const gchar *text);
 
-GeanyDocument* document_new_file_if_non_open();
+GeanyDocument* document_new_file_if_non_open(void);
 
 GeanyDocument* document_find_by_filename(const gchar *utf8_filename);
 
Index: src/symbols.c
===================================================================
--- src/symbols.c	(revision 3458)
+++ src/symbols.c	(working copy)
@@ -889,7 +889,7 @@
 		! utils_str_equal(doc->encoding, "None"))
 	{
 		setptr(utf8_name,
-			encodings_convert_to_utf8_from_charset(utf8_name, -1, doc->encoding, TRUE));
+			encodings_convert_to_utf8_from_charset(utf8_name, (gsize)-1, doc->encoding, TRUE));
 	}
 
 	return utf8_name;
Index: src/socket.c
===================================================================
--- src/socket.c	(revision 3458)
+++ src/socket.c	(working copy)
@@ -481,7 +481,7 @@
 
 	/* we never know how the input is encoded, so do the best auto detection we can */
 	if (! g_utf8_validate(buf, -1, NULL))
-		utf8_filename = encodings_convert_to_utf8(buf, -1, NULL);
+		utf8_filename = encodings_convert_to_utf8(buf, (gsize)-1, NULL);
 	else
 		utf8_filename = g_strdup(buf);
 
Index: tagmanager/read.h
===================================================================
--- tagmanager/read.h	(revision 3458)
+++ tagmanager/read.h	(working copy)
@@ -125,8 +125,8 @@
 			   const char *const fileName, const langType language );
 extern void bufferClose (void);
 extern void setBufPos (int new_position);
-extern int getBufPos ();
-extern boolean useFile ();
+extern int getBufPos (void);
+extern boolean useFile (void);
 
 #endif	/* _READ_H */
 
Index: plugins/splitwindow.c
===================================================================
--- plugins/splitwindow.c	(revision 3458)
+++ plugins/splitwindow.c	(working copy)
@@ -410,7 +410,7 @@
 };
 
 
-void plugin_cleanup()
+void plugin_cleanup(void)
 {
 	if (plugin_state != STATE_UNSPLIT)
 		on_unsplit(NULL, NULL);
Index: configure.in
===================================================================
--- configure.in	(revision 3458)
+++ configure.in	(working copy)
@@ -135,7 +135,9 @@
 # GIO checks
 gio_modules="gio-2.0 >= 2.16"
 PKG_CHECK_MODULES(GIO, [$gio_modules], have_gio=1, have_gio=0)
-AC_DEFINE_UNQUOTED(HAVE_GIO, $have_gio, [Whether GIO is available])
+if test $have_gio = 1 ; then
+	AC_DEFINE(HAVE_GIO, [], [Whether GIO is available])
+fi
 
 # --disable-deprecated switch for GTK2 purification
 AC_ARG_ENABLE(deprecated, [  --disable-deprecated    Disable deprecated GTK functions. ],